//+------------------------------------------------------------------+
//|                                                  Show orders.mq4 |
//|                        Public domain software by Ralph Ronnquist |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Public domain software by Ralph Ronnquist"
#property link      ""

#property indicator_chart_window

extern color OP_color = Green;
extern color TP_color = Blue;
extern color SL_color = Red;

int init()
{
    return(0);
}

int deinit()
{
    return(0);
}

int start()
{
    for ( int i = OrdersTotal() - 1; i >= 0; i-- ) {
        if ( ! OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) )
            continue;
        showOrder();
    }
    return(0);
}

// An order is "shown" by up to 3 lines, to indicate open price, stoploss and takeprofit.
void showOrder()
{
    drawHLine( "OP " + OrderTicket(), OrderOpenPrice(), OP_color );
    drawHLine( "TP " + OrderTicket(), OrderTakeProfit(), TP_color );
    drawHLine( "SL " + OrderTicket(), OrderStopLoss(), SL_color );
    drawVLine( "S " + OrderTicket(), OrderOpenPrice(), OrderStopLoss(), SL_color );
    drawVLine( "T " + OrderTicket(), OrderOpenPrice(), OrderTakeProfit(), TP_color );
}

void drawVLine(string name,double p0,double p1,color c)
{
    drawLine( name, OrderOpenTime(), p0, OrderOpenTime(), p1, c, false );
}

void drawHLine(string name,double p,color c)
{
    drawLine( name, OrderOpenTime(), p, Time[ 0 ] + Period() * 60, p, c, true );
}

void drawLine(string name,datetime t0,double p0,datetime t1,double p1,color c,bool back)
{
    if ( p0 == 0 || p1 == 0 )
        return;
    if ( ObjectFind( name ) < 0 ) {
        ObjectCreate( name, OBJ_TREND, 0, t0, p0, t1, p1 );
    } else {
        ObjectMove( name, 0, t0, p0 );
        ObjectMove( name, 1, t1, p1 );
    }
    ObjectSet( name, OBJPROP_COLOR, c );
    ObjectSet( name, OBJPROP_STYLE, STYLE_DASHDOT );
    ObjectSet( name, OBJPROP_BACK, back );
    ObjectSet( name, OBJPROP_RAY, false );
}